###############################################################################
#	FireWeapons(pShip, eGroup)
#	
#	Fires the specified weapon system group. (primary, secondary, tertiary)
#	
#	Args:	pShip		- the ship that is firing
#			bFiring		- whether we are starting or stopping firing
#			eGroup		- the weapon system group to look for
#						  (i.e. App.ShipClass.WG_PRIMARY, WG_SECONDARY,
#						  WG_TERTIARY)
#	
#	Return:	none
###############################################################################
import App

def SneakerFireWeapons(pShip, bFiring, eGroup):
	if (pShip != None):
		# Check if we're starting or stopping...
		if (bFiring == 1):
			# Starting.  Check if we have a target..
			pSystem = pShip.GetWeaponSystemGroup(eGroup)
			if (pSystem != None):

				##############################################sneaker98 changes
				pPhasers = pShip.GetPhaserSystem()
				if (pPhasers and pPhasers.IsTryingToFire()):

					####### for future: if no target, fire forward.. damn i wish
					####### that i had time to finish this...
					# if no target, the ship is the target
					#if (pShip.GetTarget() == None):
					#	sneakerTarget = pObject
					#	#sneakerTarget = App.ObjectClass_GetObject(pSet, sTargetObject)
					#else:
					#	sneakerTarget = pShip.GetTarget()
					#
					sneakerTarget = pShip.GetTarget ()

					if (sneakerTarget != None):
						# start a tally for hit/miss stuff
						sneakerNum = 5   # base value, good start point
						# first off, check radius. if small, less accuracy. if big: more
						if ((pShip.GetTarget()).GetRadius() <= 0.5):
							sneakerNum = sneakerNum + 1
						elif ((pShip.GetTarget()).GetRadius() >= 3):
							sneakerNum = sneakerNum - 1
						#now checking angular acceleration aka maneuvering
						sneakerAngle = pShip.GetTargetAngularVelocityTG()
						sneakerAngleX = sneakerAngle.GetX()
						sneakerAngleY = sneakerAngle.GetY()
						sneakerAngleZ = sneakerAngle.GetZ()
						if ((sneakerAngleX + sneakerAngleY + sneakerAngleZ > 0.0) and (sneakerAngleX + sneakerAngleY + sneakerAngleZ < 1.0)):
							sneakerNum = sneakerNum + 1
						elif ((sneakerAngleX + sneakerAngleY + sneakerAngleZ >= 1.0) and (sneakerAngleX + sneakerAngleY + sneakerAngleZ < 2.0)):
							sneakerNum = sneakerNum + 2
						elif ((sneakerAngleX + sneakerAngleY + sneakerAngleZ >= 2.0) and (sneakerAngleX + sneakerAngleY + sneakerAngleZ < 3.0)):
							sneakerNum = sneakerNum + 3
						#find the distance between the two ships
						snEnemyLoc = (pShip.GetTarget()).GetWorldLocation()
						snShipLoc = pShip.GetWorldLocation()
						if ((snEnemyLoc.GetX() - snShipLoc.GetX() > 125) or (snEnemyLoc.GetY() - snShipLoc.GetY() > 125) or (snEnemyLoc.GetZ() - snShipLoc.GetZ() > 125)):
							sneakerNum = sneakerNum + 1
						if ((snEnemyLoc.GetX() - snShipLoc.GetX() < -125) or (snEnemyLoc.GetY() - snShipLoc.GetY() < -125) or (snEnemyLoc.GetZ() - snShipLoc.GetZ() < -125)):
							sneakerNum = sneakerNum + 1
						if ((snEnemyLoc.GetX() - snShipLoc.GetX() > 200) or (snEnemyLoc.GetY() - snShipLoc.GetY() > 200) or (snEnemyLoc.GetZ() - snShipLoc.GetZ() > 200)):
							sneakerNum = sneakerNum + 10
						if ((snEnemyLoc.GetX() - snShipLoc.GetX() < -200) or (snEnemyLoc.GetY() - snShipLoc.GetY() < -200) or (snEnemyLoc.GetZ() - snShipLoc.GetZ() < -200)):
							sneakerNum = sneakerNum + 10
					else:
						sneakerNum = 1
					
					sneakerRandomPhaser = App.g_kSystemWrapper.GetRandomNumber(sneakerNum)
					if (sneakerRandomPhaser == 0 or sneakerRandomPhaser == 1 or sneakerRandomPhaser == 2):
						pSystem.StartFiring(sneakerTarget, pShip.GetTargetOffsetTG())
						pSystem.SetForceUpdate(1) # update and fire immediately

					elif (sneakerRandomPhaser == 3):
						kNewLocation = App.TGPoint3_GetRandomUnitVector()
						fMaxDistance = 0.3
						fMinDistance = 0.0
						fDistance = fMinDistance + (fMaxDistance - fMinDistance) * App.g_kSystemWrapper.GetRandomNumber(1000) / 1000.0

						# Scale the direction by the distance to get the position...
						kNewLocation.Scale(fDistance)
						kLocation = pShip.GetTargetOffsetTG()

						# Strip out all the XYZ's, add em together
						intX = kNewLocation.GetX() + kLocation.GetX()
						intY = kNewLocation.GetY() + kLocation.GetY()
						intZ = kNewLocation.GetZ() + kLocation.GetZ()

						kLocation.SetX(intX)
						kLocation.SetY(intY)
						kLocation.SetZ(intZ)

						pSystem.StartFiring(sneakerTarget, kLocation)
						pSystem.SetForceUpdate(1) # update and fire immediately

					elif (sneakerRandomPhaser == 4):
						kNewLocation = App.TGPoint3_GetRandomUnitVector()
						fMaxDistance = 0.6
						fMinDistance = 0.0
						fDistance = fMinDistance + (fMaxDistance - fMinDistance) * App.g_kSystemWrapper.GetRandomNumber(1000) / 1000.0

						# Scale the direction by the distance to get the position...
						kNewLocation.Scale(fDistance)
						kLocation = pShip.GetTargetOffsetTG()

						# Strip out all the XYZ's, add em together
						intX = kNewLocation.GetX() + kLocation.GetX()
						intY = kNewLocation.GetY() + kLocation.GetY()
						intZ = kNewLocation.GetZ() + kLocation.GetZ()

						kLocation.SetX(intX)
						kLocation.SetY(intY)
						kLocation.SetZ(intZ)

						pSystem.StartFiring(sneakerTarget, kLocation)
						pSystem.SetForceUpdate(1) # update and fire immediately

					elif (sneakerRandomPhaser == 5):
						kNewLocation = App.TGPoint3_GetRandomUnitVector()
						fMaxDistance = 0.9
						fMinDistance = 0.0
						fDistance = fMinDistance + (fMaxDistance - fMinDistance) * App.g_kSystemWrapper.GetRandomNumber(1000) / 1000.0

						# Scale the direction by the distance to get the position...
						kNewLocation.Scale(fDistance)
						kLocation = pShip.GetTargetOffsetTG()

						# Strip out all the XYZ's, add em together
						intX = kNewLocation.GetX() + kLocation.GetX()
						intY = kNewLocation.GetY() + kLocation.GetY()
						intZ = kNewLocation.GetZ() + kLocation.GetZ()

						kLocation.SetX(intX)
						kLocation.SetY(intY)
						kLocation.SetZ(intZ)

						pSystem.StartFiring(sneakerTarget, kLocation)
						pSystem.SetForceUpdate(1) # update and fire immediately

					elif (sneakerRandomPhaser == 6):
						kNewLocation = App.TGPoint3_GetRandomUnitVector()
						fMaxDistance = 1.2
						fMinDistance = 0.0
						fDistance = fMinDistance + (fMaxDistance - fMinDistance) * App.g_kSystemWrapper.GetRandomNumber(1000) / 1000.0

						# Scale the direction by the distance to get the position...
						kNewLocation.Scale(fDistance)
						kLocation = pShip.GetTargetOffsetTG()

						# Strip out all the XYZ's, add em together
						intX = kNewLocation.GetX() + kLocation.GetX()
						intY = kNewLocation.GetY() + kLocation.GetY()
						intZ = kNewLocation.GetZ() + kLocation.GetZ()

						kLocation.SetX(intX)
						kLocation.SetY(intY)
						kLocation.SetZ(intZ)

						pSystem.StartFiring(sneakerTarget, kLocation)
						pSystem.SetForceUpdate(1) # update and fire immediately

					elif (sneakerRandomPhaser == 7):
						kNewLocation = App.TGPoint3_GetRandomUnitVector()
						fMaxDistance = 1.5
						fMinDistance = 0.0
						fDistance = fMinDistance + (fMaxDistance - fMinDistance) * App.g_kSystemWrapper.GetRandomNumber(1000) / 1000.0

						# Scale the direction by the distance to get the position...
						kNewLocation.Scale(fDistance)
						kLocation = pShip.GetTargetOffsetTG()

						# Strip out all the XYZ's, add em together
						intX = kNewLocation.GetX() + kLocation.GetX()
						intY = kNewLocation.GetY() + kLocation.GetY()
						intZ = kNewLocation.GetZ() + kLocation.GetZ()

						kLocation.SetX(intX)
						kLocation.SetY(intY)
						kLocation.SetZ(intZ)

						pSystem.StartFiring(sneakerTarget, kLocation)
						pSystem.SetForceUpdate(1) # update and fire immediately

					else:
						kNewLocation = App.TGPoint3_GetRandomUnitVector()
						fMaxDistance = 3.0
						fMinDistance = 0.0
						fDistance = fMinDistance + (fMaxDistance - fMinDistance) * App.g_kSystemWrapper.GetRandomNumber(1000) / 1000.0

						# Scale the direction by the distance to get the position...
						kNewLocation.Scale(fDistance)
						kLocation = pShip.GetTargetOffsetTG()

						# Strip out all the XYZ's, add em together
						intX = kNewLocation.GetX() + kLocation.GetX()
						intY = kNewLocation.GetY() + kLocation.GetY()
						intZ = kNewLocation.GetZ() + kLocation.GetZ()

						kLocation.SetX(intX)
						kLocation.SetY(intY)
						kLocation.SetZ(intZ)

						pSystem.StartFiring(sneakerTarget, kLocation)
						pSystem.SetForceUpdate(1) # update and fire immediately
				else:
					pSystem.StartFiring(pShip.GetTarget(), pShip.GetTargetOffsetTG())
					pSystem.SetForceUpdate(1) # update and fire immediately
				#############################################end sneaker98 changes

		else:
			# Stopping.
			pSystem = pShip.GetWeaponSystemGroup(eGroup)
			if (pSystem != None):
				pSystem.StopFiring()

	return